#ifndef SYS_TYPES_H_
#define SYS_TYPES_H_ 1

#include <stdint.h>

/* mode_t shall be an integer type. */
typedef uint64_t mode_t;

/* nlink_t, uid_t, gid_t, and id_t shall be integer types. */
typedef uint64_t nlink_t;
typedef uint64_t uid_t;
typedef uint64_t gid_t;
typedef uint64_t id_t;

/* blkcnt_t and off_t shall be signed integer types. */
typedef int64_t blkcnt_t;
typedef int64_t off_t;

/* [XSI] [Option Start] fsblkcnt_t, fsfilcnt_t, [Option End]  and ino_t shall
 * be defined as unsigned integer types.
 */
typedef uint64_t fsblkcnt_t;
typedef uint64_t fsfilcnt_t;
typedef uint64_t ino_t;

/* size_t shall be an unsigned integer type. */
typedef uint64_t size_t;

/* blksize_t, pid_t, and ssize_t shall be signed integer types. */
typedef int64_t blksize_t;
typedef int64_t pid_t;
typedef int64_t ssize_t;

/* time_t and clock_t shall be integer or real-floating types. */
typedef uint64_t clock_t;
typedef uint64_t time_t;

typedef uint64_t dev_t;

#endif
